Option Strict Off
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Globalization
Imports System.Threading
Imports NXOpen
Imports NXOpen.Annotations
Imports NXOpen.UI
Imports NXOpen.UF
Imports NXOpen.Utilities

Imports NXOpen.Assemblies
Imports System.Windows.Forms


Module Gap
Public theSession As Session = Session.GetSession()
Public ufs As UFSession = UFSession.GetUFSession()

Public workPart As Part = theSession.Parts.Work
Public lw As ListingWindow = theSession.ListingWindow

Public Gap_size As Double = 3
Public ende As integer = 0

    '%%%%% change the break symbol size to your liking
    Public inchSymbolLength As Double = Gap_size
    Public inchSymbolHeight As Double = Gap_size
    Public mmSymbolLength As Double = Gap_size
    Public mmSymbolHeight As Double = Gap_size
    '%%%%%
	
Declare Sub MACRO_playback_from_usertool Lib "libugui" Alias "?MACRO_playback_from_usertool@@YAXPEBD@Z" (ByVal lpName As String)
Sub Main

        Dim myDialog As New Dialog1
        myDialog.myPart = workPart.FullPath
        myDialog.ShowDialog()
		
		inchSymbolLength = Gap_size
		inchSymbolHeight = Gap_size
		mmSymbolLength = Gap_size
		mmSymbolHeight = Gap_size
		if ende = 0 Then
		
		else if ende = 1 Then
		
		Dim myExtensionLines As New List(Of Line)
		Dim dim1ExtensionLines As New List(Of Line)
        Dim dim2ExtensionLines As New List(Of Line)
 
        Dim undoStack As New Stack(Of Session.UndoMarkId)
 
        lw.Open()
 
        Dim myDim1 As Annotations.Dimension
        Dim myDim2 As Annotations.Dimension
        Dim keepGoing As Boolean = True
 
        While keepGoing
 
            Dim markId1 As Session.UndoMarkId
            Dim markText As String = "Break Dimension Line"
            markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible, markText)
 
            undoStack.Push(markId1)
 
            'select dim 1
            If SelectDimension("Select first dimension", myDim1) = Selection.Response.Cancel Then
                keepGoing = False
                Dim myUndo As Session.UndoMarkId = undoStack.Pop
                theSession.UndoToMark(myUndo, markText)
                theSession.DeleteUndoMark(myUndo, markText)
                Return
            End If
 
            Try
                GetExtensionLines(myDim1, dim1ExtensionLines)
 
            Catch ex As Exception
 
                Dim myUndo As Session.UndoMarkId = undoStack.Pop
                theSession.UndoToMark(myUndo, markText)
                theSession.DeleteUndoMark(myUndo, markText)
 
                If ex.Message = "Dimension has no extension lines" Then
                    MessageBox.Show("The selected dimension has no extension lines, please choose new dimensions or press Cancel", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                    Continue While
                Else
                    'lw.WriteLine("Error: " & ex.Message)
                    MessageBox.Show("An unexpected error has occurred, the journal will now exit", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
 
            End Try
 
            'select dim 2
            If SelectDimension("Select second dimension", myDim2) = Selection.Response.Cancel Then
 
                keepGoing = False
                Dim myUndo As Session.UndoMarkId = undoStack.Pop
                theSession.UndoToMark(myUndo, markText)
                theSession.DeleteUndoMark(myUndo, markText)
                Return
 
            End If
 
            Try
                GetExtensionLines(myDim2, dim2ExtensionLines)
 
            Catch ex As Exception
 
                DeleteTempLines(dim1ExtensionLines)
                dim1ExtensionLines.Clear()
 
                Dim myUndo As Session.UndoMarkId = undoStack.Pop
                theSession.UndoToMark(myUndo, markText)
                theSession.DeleteUndoMark(myUndo, markText)
 
                If ex.Message = "Dimension has no extension lines" Then
                    MessageBox.Show("The selected dimension has no extension lines, please choose new dimensions or press Cancel", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                    Continue While
                Else
                    MessageBox.Show("An unexpected error has occurred, the journal will now exit", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
 
            End Try
 
            'create break symbol in first selected dimension
            Try
                CreateIntersectionPoints(myDim1, dim1ExtensionLines, dim2ExtensionLines)
 
            Catch ex As Exception
                lw.WriteLine("Error: " & ex.Message)
                Dim myUndo As Session.UndoMarkId = undoStack.Pop
                theSession.UndoToMark(myUndo, markText)
                theSession.DeleteUndoMark(myUndo, markText)
 
            Finally
                DeleteTempLines(dim1ExtensionLines)
                DeleteTempLines(dim2ExtensionLines)
                dim1ExtensionLines.Clear()
                dim2ExtensionLines.Clear()
 
            End Try
 
        End While
'%%%%%%%%%%%Manual positioning		
		else if ende = 2 Then
 
		Dim noteDim As Annotation
        Dim noteDimOrigin As Point3d = Nothing
        Dim letterPref As LetteringPreferences = Nothing
        Dim symbolPref As SymbolPreferences = Nothing
        Dim dimpref As DimensionPreferences = Nothing
        Dim noteNumber As Integer
        Dim letterangle As Double
        Dim dimangle As Double
        Dim input As String
        Dim theAnnotationManager As NXOpen.Annotations.AnnotationManager = workPart.Annotations
        Dim idTextAngle As Double
 
lw.Open()
 
' Select the dimension
 Dim dim1 As Dimension
 While select_a_dimension("Select Dimension", dim1) = Selection.Response.Ok
 Dim markId1 As Session.UndoMarkId
 markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible,"Break Dimension")
 
' Select the location
 Dim location As Point3d
 pick_screen_position(location)
 'lw.WriteLine("Dimension: " & dim1.ToString())
 'lw.WriteLine("Position: X=" & location.x.ToString() & " Y=" &location.y.ToString())
 
 ' get angle

 Dim theDim As Dimension = dim1
 dimpref = theDim.GetDimensionPreferences()
 dimangle = dimpref.TextOrienationAngle
 'lw.WriteLine("Angle: " & dimangle.ToString())
 
' Create the symbol
 ufs.Drf.SetUgdefaultSbfFile()
 
Dim symbol_data As UFDrf.SymbolCreateData
 ufs.Drf.InitSymbolCreateData(symbol_data)
 symbol_data.length = Gap_size
 symbol_data.height = Gap_size
 'symbol_data.angle = dimangle
 Dim anchor As Point = workPart.Points.CreatePoint(location)
 
 symbol_data.anchor_tag = anchor.Tag
 symbol_data.symbol_name = "GAP25"
 
Dim symbol_tag As Tag
 ufs.Drf.PlaceSymbol(symbol_data, False, False, symbol_tag)
 
ufs.Drf.AddSymbolToObject(symbol_data, dim1.Tag)
 Dim tag_name As String
 tag_name = symbol_tag.toString
 'lw.WriteLine(tag_name)
 
 Dim dimtype = symbol_data.toString 
 'lw.writeLine ("dimtype: " & dimtype.ToString)
 
 Dim zaehler As Integer = 0
 Dim mpi(99)As Integer 
 Dim mpr(69) As Double 
 Dim radius_val As String
 Dim diameter_val As String
UFs.DRF.AskObjectPreferences(dim1.Tag, mpi, mpr, radius_val, diameter_val)

while zaehler < 100
 'lw.WriteLine("mpi(" & zaehler & "): " & mpi(zaehler))
 zaehler += 1
 end while
 zaehler = 0
 while zaehler < 70
 'lw.WriteLine("mpr(" & zaehler & "): " & mpr(zaehler))
 zaehler += 1
 end while
 'lw.WriteLine("rad:" & radius_val)
 'lw.WriteLine("dia: " & diameter_val)
 macro
 exit sub
 End While

 '%%%%%%%% move gap
 else if ende = 3 Then
 macro
 
 '%%%%%%%%% delete gap
 else if ende = 4 Then
 
  Dim noteDim As Annotation
        Dim noteDimOrigin As Point3d = Nothing
        Dim letterPref As LetteringPreferences = Nothing
        Dim symbolPref As SymbolPreferences = Nothing
        Dim dimpref As DimensionPreferences = Nothing
        Dim noteNumber As Integer
        Dim letterangle As Double
        Dim dimangle As Double
        Dim input As String
        Dim theAnnotationManager As NXOpen.Annotations.AnnotationManager = workPart.Annotations
        Dim idTextAngle As Double
		Dim dimtype As Type
 
lw.Open()
 
' Select the dimension
 Dim dim1 As Dimension
 While select_a_dimension("Select Dimension to Remove Gaps", dim1) = Selection.Response.Ok
 Dim markId1 As Session.UndoMarkId
 markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible,"Break Dimension")
 dimtype = dim1.GetType 
 'lw.writeLine ("dimtype: " & dimtype.ToString)
 
Dim symbol_tag As Tag
 
 Dim zaehler As Integer = 0
 Dim mpi(99)As Integer 
 Dim mpr(69) As Double 
 Dim radius_val As String
 Dim diameter_val As String
UFs.DRF.AskObjectPreferences(dim1.Tag, mpi, mpr, radius_val, diameter_val)

'mpi mpr auslesen und ins Listfenster schreiben
while zaehler < 100
 'lw.WriteLine("mpi(" & zaehler & "): " & mpi(zaehler))
 zaehler += 1
 end while
 zaehler = 0
 while zaehler < 70
 'lw.WriteLine("mpr(" & zaehler & "): " & mpr(zaehler))
 zaehler += 1
 end while
 'lw.WriteLine("rad:" & radius_val)
 'lw.WriteLine("dia: " & diameter_val)

 
 'loschen der gaps
 'beide Linien
	Dim dimensionPreferences2 As Annotations.DimensionPreferences
	dimensionPreferences2 = dim1.GetDimensionPreferences()
	
	Dim lineAndArrowPreferences2 As Annotations.LineAndArrowPreferences
	lineAndArrowPreferences2 = dim1.GetLineAndArrowPreferences()
  if mpi(2) = 1 Then
	
	'lw.writeline (dimensionPreferences2.tostring)
	
	'Extension Line aus- und einblenden
	dimensionPreferences2.ExtensionLineDisplay = Annotations.ExtensionLineDisplay.none
	dim1.SetDimensionPreferences(dimensionPreferences2)

	dimensionPreferences2.ExtensionLineDisplay = Annotations.ExtensionLineDisplay.two
	dim1.SetDimensionPreferences(dimensionPreferences2)
  end if

  'nur first Line
  if mpi(2) = 2 Then

	'lw.writeline (dimensionPreferences2.tostring)
	
	'Extension Line aus- und einblenden
	dimensionPreferences2.ExtensionLineDisplay = Annotations.ExtensionLineDisplay.none
	dim1.SetDimensionPreferences(dimensionPreferences2)

	dimensionPreferences2.ExtensionLineDisplay = Annotations.ExtensionLineDisplay.first
	dim1.SetDimensionPreferences(dimensionPreferences2)
  end if

  'nur second Line
  if mpi(2) = 3 Then

	'lw.writeline (dimensionPreferences2.tostring)
	
	'Extension Line aus- und einblenden
	dimensionPreferences2.ExtensionLineDisplay = Annotations.ExtensionLineDisplay.none
	dim1.SetDimensionPreferences(dimensionPreferences2)

	dimensionPreferences2.ExtensionLineDisplay = Annotations.ExtensionLineDisplay.second
	dim1.SetDimensionPreferences(dimensionPreferences2)
  end if  
  
    'beide Pfeile
  if mpi(32) = 1 Then

	'Pfeillinie aus- und einblenden
	dimensionPreferences2.ArrowDisplay = Annotations.ArrowDisplay.none
	dim1.SetDimensionPreferences(dimensionPreferences2)

	dimensionPreferences2.ArrowDisplay = Annotations.ArrowDisplay.two
	dim1.SetDimensionPreferences(dimensionPreferences2)
  end if
  
      'nur erster Pfeil
  if mpi(32) = 2 Then

	'Pfeillinie aus- und einblenden
	dimensionPreferences2.ArrowDisplay = Annotations.ArrowDisplay.none
	dim1.SetDimensionPreferences(dimensionPreferences2)

	dimensionPreferences2.ArrowDisplay = Annotations.ArrowDisplay.first
	dim1.SetDimensionPreferences(dimensionPreferences2)
  end if
  
      'nur second Pfeil
  if mpi(32) = 3 Then

	'Pfeillinie aus- und einblenden
	dimensionPreferences2.ArrowDisplay = Annotations.ArrowDisplay.none
	dim1.SetDimensionPreferences(dimensionPreferences2)

	dimensionPreferences2.ArrowDisplay = Annotations.ArrowDisplay.second
	dim1.SetDimensionPreferences(dimensionPreferences2)
  end if
  


 dimensionPreferences2.Dispose()
 
 Dim markId2 As Session.UndoMarkId
markId2 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Edit Object Preferences")
 Dim nErrs2 As Integer
nErrs2 = theSession.UpdateManager.DoUpdate(markId2)

 
 End While
 
 
 end if
    End Sub
	
	Sub macro


 Dim markId2 As Session.UndoMarkId
markId2 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Edit Object Preferences")
 Dim nErrs2 As Integer
nErrs2 = theSession.UpdateManager.DoUpdate(markId2)
 
 MACRO_playback_from_usertool("C:\temp\move_gap_aufzeichnung2.macro")

	
	end sub	
	
 
    Function SelectDimension(ByVal prompt As String, ByRef selObj As TaggedObject) As Selection.Response
 
        Dim theUI As UI = UI.GetUI
        Dim title As String = "Select a dimension"
        Dim includeFeatures As Boolean = False
        Dim keepHighlighted As Boolean = False
        Dim selAction As Selection.SelectionAction = Selection.SelectionAction.ClearAndEnableSpecific
        Dim cursor As Point3d
        Dim scope As Selection.SelectionScope = Selection.SelectionScope.WorkPart
        Dim selectionMask_array(0) As Selection.MaskTriple
 
        With selectionMask_array(0)
            .Type = UFConstants.UF_dimension_type
            .Subtype = UFConstants.UF_all_subtype
        End With
 
        Dim resp As Selection.Response = theUI.SelectionManager.SelectTaggedObject(prompt, _
         title, scope, selAction, _
         includeFeatures, keepHighlighted, selectionMask_array, _
         selObj, cursor)
        If resp = Selection.Response.ObjectSelected OrElse resp = Selection.Response.ObjectSelectedByName Then
            Return Selection.Response.Ok
        Else
            Return Selection.Response.Cancel
        End If
 
    End Function
 
    Sub GetExtensionLines(ByVal tempDim As Annotations.Dimension, ByRef extLines As List(Of Line))
 
        Dim cd1 As Annotations.ComponentData = workPart.Annotations.CreateComponentData(tempDim)
        Dim lc1() As Annotations.LineComponent = cd1.GetLineComponents()
 
        For Each thisLineComponent As Annotations.LineComponent In lc1
 
            If thisLineComponent.Type = Annotations.LineComponent.LineType.Extension Then
                Dim sp As Point3d = thisLineComponent.StartPoint
                Dim ep As Point3d = thisLineComponent.EndPoint
                Dim extLine As Line = workPart.Curves.CreateLine(sp, ep)
                extLines.Add(extLine)
            End If
 
        Next
 
        If extLines.Count = 0 Then
            Throw New ApplicationException("Dimension has no extension lines")
        End If
 
    End Sub
 
    Function intersectionLineLine(ByVal line1 As Line, ByVal line2 As Line) As Point
 
        'line segment intersection test reference:
        'http://www-cs.ccny.cuny.edu/~wolberg/capstone/intersection/Intersection%20point%20of%20two%20lines.html
 
        Dim myModelingTolerance As Double
        ufs.Modl.AskDistanceTolerance(myModelingTolerance)
        'lw.WriteLine("modeling tolerance: " & myModelingTolerance.ToString)
 
        Dim x1 As Double = line1.StartPoint.X
        Dim x2 As Double = line1.EndPoint.X
        Dim x3 As Double = line2.StartPoint.X
        Dim x4 As Double = line2.EndPoint.X
        Dim y1 As Double = line1.StartPoint.Y
        Dim y2 As Double = line1.EndPoint.Y
        Dim y3 As Double = line2.StartPoint.Y
        Dim y4 As Double = line2.EndPoint.Y
 
        Dim ua As Double
        Dim ub As Double
 
        Dim intPt As Point3d
 
        Dim denom As Double
        denom = ((y4 - y3) * (x2 - x1)) - ((x4 - x3) * (y2 - y1))
        'lw.WriteLine("denom: " & denom.ToString)
 
        If Math.Abs(denom) < myModelingTolerance Then
            'lines are parallel or nearly parallel
            'lw.WriteLine("lines parallel or nearly parallel")
            Return Nothing
        End If
 
        ua = (((x4 - x3) * (y1 - y3)) - ((y4 - y3) * (x1 - x3))) / denom
        ub = (((x2 - x1) * (y1 - y3)) - ((y2 - y1) * (x1 - x3))) / denom
 
        If (ua > 0 And ua < 1) And (ub > 0 And ub < 1) Then
 
            intPt.X = x1 + ua * (x2 - x1)
            intPt.Y = y1 + ua * (y2 - y1)
            intPt.Z = 0
 
            'lw.WriteLine("intPt: " & intPt.ToString)
 
            Dim retPt As Point = workPart.Points.CreatePoint(intPt)
            Return retPt
 
        Else
            'no intersection on the line segments
            'lw.WriteLine("no intersection on line segments")
            Return Nothing
        End If
 
    End Function
 
    Sub CreateIntersectionPoints(ByVal theDim As Annotations.Dimension, _
                                 ByVal extLines1 As List(Of Line), _
                                 ByVal extLines2 As List(Of Line))
 
        Dim i As Integer
        Dim j As Integer
        Dim breakPt As Point
        Dim offsetPt As Point
        Dim angle As Double
        Dim dimsIntersect As Boolean = False
        Dim offsetDirection As Integer
 
        Dim symbolLength As Double
        If workPart.PartUnits = BasePart.Units.Millimeters Then
            symbolLength = mmSymbolLength
        Else
            symbolLength = inchSymbolLength
        End If
 
        Dim distScalar As Scalar
        distScalar = workPart.Scalars.CreateScalar(symbolLength * 0.5, Scalar.DimensionalityType.Length, SmartObject.UpdateOption.WithinModeling)
 
        For i = 0 To extLines1.Count - 1
            For j = 0 To extLines2.Count - 1
                breakPt = Nothing
                breakPt = intersectionLineLine(extLines1.Item(i), extLines2.Item(j))
                If Not breakPt Is Nothing Then
                    dimsIntersect = True
                    angle = Math.Atan2(extLines1.Item(i).EndPoint.Y - extLines1.Item(i).StartPoint.Y, extLines1.Item(i).EndPoint.X - extLines1.Item(i).StartPoint.X)
                    angle = (angle * 180) / Math.PI
 
                    'normalize the angle
                    If angle < 0 Then
                        angle += 360
                    End If
 
                    'gap location changes slightly based on the angle of the extension line
                    'lines in quadrant 1 & 4 need to be shifted in (toward start point of extension line)
                    'lines in quadrant 2 & 3 need to be shifted out (toward end point of extension line)
                    If angle > 270 Or angle <= 90 Then
                        'line is somewhere in quadrant 1 or 4, shift break point toward start point of line
                        offsetDirection = Sense.Reverse
                    Else
                        'line is somewhere in quadrant 2 or 3, shift break point toward end point of line
                        offsetDirection = Sense.Forward
                    End If
 
                    'offset breakpoint 1/2 gap width
                    offsetPt = breakPt
                    breakPt = workPart.Points.CreatePoint(extLines1.Item(i), offsetPt, distScalar, PointCollection.AlongCurveOption.Distance, offsetDirection, SmartObject.UpdateOption.WithinModeling)
 
                    'breakPt.SetVisibility(SmartObject.VisibilityOption.Visible)
                    BreakDim(theDim, breakPt)
 
                End If
            Next
        Next
 
        If Not dimsIntersect Then
            Throw New ApplicationException("Dim extension lines do not intersect")
        End If
 
    End Sub
 
    Sub BreakDim(ByVal theDim As Annotations.Dimension, ByVal thePoint As Point)
 
        Dim myDimLinePrefs As Annotations.LineAndArrowPreferences
        myDimLinePrefs = theDim.GetLineAndArrowPreferences
 
        Dim breakLocation As Point3d = thePoint.Coordinates
 
        ' Create the symbol
        ufs.Drf.SetUgdefaultSbfFile()
 
        Dim symbol_data As UFDrf.SymbolCreateData
        ufs.Drf.InitSymbolCreateData(symbol_data) 
 
        If workPart.PartUnits = BasePart.Units.Millimeters Then
            symbol_data.length = mmSymbolLength
            symbol_data.height = mmSymbolHeight
        Else
            symbol_data.length = inchSymbolLength
            symbol_data.height = inchSymbolHeight
        End If
 
        symbol_data.angle = 0
 
        Dim anchor As Point = workPart.Points.CreatePoint(breakLocation)
        symbol_data.anchor_tag = anchor.Tag
        symbol_data.symbol_name = "GAP25"
 
        Dim symbol_tag As Tag
        ufs.Drf.PlaceSymbol(symbol_data, False, False, symbol_tag)
 
        ufs.Drf.AddSymbolToObject(symbol_data, theDim.Tag)
 
    End Sub
 
    Sub DeleteTempLines(ByVal extLines As List(Of Line))
 
        'delete temp lines
        Try
            Dim markId2 As Session.UndoMarkId
            markId2 = theSession.SetUndoMark(Session.MarkVisibility.Invisible, "Delete")
 
            Dim nErrs1 As Integer
            nErrs1 = theSession.UpdateManager.AddToDeleteList(extLines.ToArray)
 
            Dim notifyOnDelete2 As Boolean
            notifyOnDelete2 = theSession.Preferences.Modeling.NotifyOnDelete
 
            Dim nErrs2 As Integer
            nErrs2 = theSession.UpdateManager.DoUpdate(markId2)
 
        Catch ex As NXException
 
        End Try
 
    End Sub
 
    Public Function GetUnloadOption(ByVal dummy As String) As Integer
 
        'Unloads the image when the NX session terminates
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.AtTermination
 
    End Function
	
	Function select_a_dimension(ByVal prompt As String, ByRef obj As Dimension)
 Dim ui As UI = GetUI()
 Dim mask(0) As Selection.MaskTriple
 With mask(0)
 .Type = UFConstants.UF_dimension_type
 .Subtype = 0
 .SolidBodySubtype = 0
 End With
 Dim cursor As Point3d = Nothing
 
Dim resp As Selection.Response = _
 ui.SelectionManager.SelectObject(prompt, prompt, _
 Selection.SelectionScope.AnyInAssembly, _
 Selection.SelectionAction.ClearAndEnableSpecific, _
 False, False, mask, obj, cursor)
 
If resp = Selection.Response.ObjectSelected Or _
 resp = Selection.Response.ObjectSelectedByName Then
 Return Selection.Response.Ok
 Else
 Return Selection.Response.Cancel
 End If
 
 End Function
 
Function pick_screen_position(ByRef location As Point3d) As Selection.Response
 
 Dim ui As UI = GetUI()
 Dim resp As Selection.DialogResponse = Selection.DialogResponse.None
 Dim theSession As Session = Session.GetSession()
 Dim ufs As UFSession = UFSession.GetUFSession()
 Dim workPart As Part = theSession.Parts.Work
 Dim displayPart As Part = theSession.Parts.Display
 Dim lw As ListingWindow = theSession.ListingWindow

 Dim localView As NXOpen.View
 resp = ui.SelectionManager.SelectScreenPosition("Pick Position:",localView, location)
 location.X = location.X -0
 location.Y = location.Y -0

 If resp <> Selection.DialogResponse.Back And _
 resp <> Selection.DialogResponse.Cancel Then
 Return Selection.Response.Ok
 Else
 Return Selection.Response.Cancel
 End If
 
End Function




Public Class Dialog1
    Public myPart As String
	
	'Auto positioning
	Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
		ende = 1
	If Double.TryParse(TextBox1.Text, Gap_size) Then
	else
	MsgBox(TextBox1.Text & " is no valid value for Gap Size, the default of 3 is used instead.")
	TextBox1.Text = "3"
	end if
		
		Try	
			Gap_size = Convert.ToDouble(TextBox1.Text) 
			'lw.writeline (Gap_size)
		Catch ex As ApplicationException
            'attribute does not exist
            Gap_size = 3
			lw.writeline ("Wrong Gap_size: " & Gap_size)
        End Try
		
        Me.Close()	
    End Sub
	
	'manual positioning
	Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
		Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
		ende = 2
	If Double.TryParse(TextBox1.Text, Gap_size) Then
	else
	MsgBox(TextBox1.Text & " is no valid value for Gap Size, the default of 3 is used instead.")
	TextBox1.Text = "3"
	end if
		Try	
			Gap_size = Convert.ToDouble(TextBox1.Text) 
			'lw.writeline (Gap_size)
		Catch ex As ApplicationException
            'attribute does not exist
            Gap_size = 3
			lw.writeline ("Wrong Gap_size: " & Gap_size)
        End Try
		
        Me.Close()	

    End Sub
	
	
	
	'move gap
	Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
		Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
		ende = 3
		
        Me.Close()	

    End Sub
	
	'delete gap
	Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
		Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
		ende = 4
		
        Me.Close()	

    End Sub
	
    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
		ende = 0
        Me.Close()
		
    End Sub
	
	
	Sub Dialog1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

			TextBox1.Text = Gap_size
		
	End Sub
	
	
	
End Class


<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Partial Class Dialog1
    Inherits System.Windows.Forms.Form

    'Das Formular berschreibt den Lschvorgang, um die Komponentenliste zu bereinigen.
    <System.Diagnostics.DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        Try
            If disposing AndAlso components IsNot Nothing Then
                components.Dispose()
            End If
        Finally
            MyBase.Dispose(disposing)
        End Try
    End Sub

    'Wird vom Windows Form-Designer bentigt.
    Private components As System.ComponentModel.IContainer

    'Hinweis: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich.
    'Das Bearbeiten ist mit dem Windows Form-Designer mglich.  
    'Das Bearbeiten mit dem Code-Editor ist nicht mglich.
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.Cancel_Button = New System.Windows.Forms.Button()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.TextBox1 = New System.Windows.Forms.TextBox()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.Button2 = New System.Windows.Forms.Button()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.GroupBox1 = New System.Windows.Forms.GroupBox()
        Me.Button3 = New System.Windows.Forms.Button()
        Me.GroupBox2 = New System.Windows.Forms.GroupBox()
        Me.Button4 = New System.Windows.Forms.Button()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.SuspendLayout()
        '
        'Cancel_Button
        '
        Me.Cancel_Button.Anchor = System.Windows.Forms.AnchorStyles.None
        Me.Cancel_Button.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Cancel_Button.Location = New System.Drawing.Point(215, 325)
        Me.Cancel_Button.Margin = New System.Windows.Forms.Padding(4)
        Me.Cancel_Button.Name = "Cancel_Button"
        Me.Cancel_Button.Size = New System.Drawing.Size(88, 28)
        Me.Cancel_Button.TabIndex = 1
        Me.Cancel_Button.Text = "Cancel"
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(46, 20)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(70, 17)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "Gap Size:"
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(158, 17)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(39, 22)
        Me.TextBox1.TabIndex = 3
        Me.TextBox1.Text = "2"
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(33, 21)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(105, 49)
        Me.Button1.TabIndex = 0
        Me.Button1.Text = "Automatic Positioning"
        Me.Button1.UseVisualStyleBackColor = True
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(33, 80)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(105, 49)
        Me.Button2.TabIndex = 1
        Me.Button2.Text = "Manual Positioning"
        Me.Button2.UseVisualStyleBackColor = True
        '
        'Label2
        '
        Me.Label2.AutoSize = True
        Me.Label2.Location = New System.Drawing.Point(157, 29)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(141, 34)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "(only for intersecting " & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "extension lines)"
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'GroupBox1
        '
        Me.GroupBox1.BackColor = System.Drawing.SystemColors.ControlLight
        Me.GroupBox1.Controls.Add(Me.Button2)
        Me.GroupBox1.Controls.Add(Me.Label2)
        Me.GroupBox1.Controls.Add(Me.Button1)
        Me.GroupBox1.Location = New System.Drawing.Point(-2, 55)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(378, 137)
        Me.GroupBox1.TabIndex = 7
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Create"
        '
        'Button3
        '
        Me.Button3.Location = New System.Drawing.Point(33, 21)
        Me.Button3.Name = "Button3"
        Me.Button3.Size = New System.Drawing.Size(105, 34)
        Me.Button3.TabIndex = 2
        Me.Button3.Text = "Move Gaps"
        Me.Button3.UseVisualStyleBackColor = True
        '
        'GroupBox2
        '
        Me.GroupBox2.BackColor = System.Drawing.SystemColors.ControlLight
        Me.GroupBox2.Controls.Add(Me.Button4)
        Me.GroupBox2.Controls.Add(Me.Button3)
        Me.GroupBox2.Location = New System.Drawing.Point(-2, 207)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(489, 105)
        Me.GroupBox2.TabIndex = 8
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "Modify"
        '
        'Button4
        '
        Me.Button4.Location = New System.Drawing.Point(33, 65)
        Me.Button4.Name = "Button4"
        Me.Button4.Size = New System.Drawing.Size(105, 34)
        Me.Button4.TabIndex = 3
        Me.Button4.Text = "Delete Gaps"
        Me.Button4.UseVisualStyleBackColor = True
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 5.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(6, 343)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(174, 12)
        Me.Label3.TabIndex = 9
        Me.Label3.Text = "Dimension Intersection Gap  V1.0"
        '
        'Dialog1
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(8.0!, 16.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
        Me.CancelButton = Me.Cancel_Button
        Me.ClientSize = New System.Drawing.Size(315, 362)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.GroupBox1)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.Cancel_Button)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Margin = New System.Windows.Forms.Padding(4)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Dialog1"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Dimension Intersection Gaps"
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox1.PerformLayout()
        Me.GroupBox2.ResumeLayout(False)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub
    Friend WithEvents Cancel_Button As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents Button3 As System.Windows.Forms.Button
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents Button4 As System.Windows.Forms.Button
    Friend WithEvents Label3 As System.Windows.Forms.Label

End Class
End Module